(princ "\nGLOBALC by CADworx ")

(defun initerr ()
      (setq temperr *error* *error* *colorerr*)
)

(defun *colorerr* (errmsg)
      (command nil nil nil)
      (if (not (member errmsg '("console break" "Function Cancelled")))
        (princ (strcat "\nError: " errmsg))
      )
      (setq *error* temperr)
      (princ)
)

(defun draw_color (oldcolnr newcolnr /)
  (setq oldcolor (car (nth LST_ID lst))
        newcolor (cadr (nth LST_ID lst)))
  (start_image box_num_old)
  (fill_image 0 0 (dimx_tile box_num_old) (dimy_tile box_num_old) (fix (atof oldcolnr)))
  (end_image)
  (start_image box_num_new)
  (fill_image 0 0 (dimx_tile box_num_new) (dimy_tile box_num_new) (fix (atof newcolnr)))
  (end_image)
)

(defun get_color (/)
  (setq vnewcolor newcolor
        newcolor (acad_colordlg (fix (atof vnewcolor))))
  (if (not newcolor)
    (setq newcolor vnewcolor)
    (progn
      (setq newcolor (rtos newcolor 2 0)
            oldnr (assoc oldcolor lst)
            vnewcolor newcolor
            nlst nil
            lst (subst (list oldcolor newcolor) oldnr lst))
    )))

(defun dxf_data (dxf_code dxf_elist)
  (cdr (assoc dxf_code dxf_elist))
)

(defun scan_for_colors (/ rst l col)
(princ "\nScanning drawing for colors... please wait")(princ)
  (setq lay_lst nil rst T)
  (while (setq l (tblnext "LAYER" rst))
    (setq col (dxf_data 62 l) rst nil)
    (if (not (member (rtos col 2 0) lay_lst))
      (setq lay_lst (cons (rtos col 2 0) lay_lst))
    )
  )
  (setq sslst nil ent_lst nil blk_lst nil lst nil rst T)
  (while
    (setq blk (tblnext "BLOCK" rst)
          rst nil
          nent (dxf_data -2 blk))
    (while (setq nent (entnext nent))
      (setq entl (entget nent))
      (if (and (setq kolor (dxf_data 62 entl)) (/= kolor 0) (/= (dxf_data 0 entl) "SEQEND"))
        (progn
          (setq kolor$ (rtos kolor 2 0))
          (if (not (member kolor$ blk_lst))
            (setq blk_lst (cons kolor$ blk_lst))
          )))))

     (if (setq ent (entnext))
    (progn
      (setq el (entget ent)
            col (dxf_data 62 el))
      (if col
        (progn
          (setq col$ (rtos col 2 0))
          (if (not (member col$ ent_lst))
            (progn
              (setq ent_lst (cons col$ ent_lst)
                    sslst (cons (cons col (ssget "x" (list (cons 62 col)))) sslst))
            ))))
      (setq nent ent)
      (while (setq nent (entnext nent))
        (setq el (entget nent)
              col (dxf_data 62 el))
        (if col
          (progn
            (setq col$ (rtos col 2 0))
            (if (not (member col$ ent_lst))
              (progn
                (setq ent_lst (cons col$ ent_lst)
                      sslst (cons (cons col (ssget "x" (list (cons 62 col)))) sslst))
              ))))))

    (setq ent_lst nil)
   )
(princ "\nSelect colors to change...")(princ)
)

(defun go_change (/ tel color1 color2 x ss _lst rst entl kolor nent)
  (foreach x lst (if (member (car x) ent_lst)
                   (progn
                     (setq color1 (car x)
                           color2 (cadr x))
                     (if (/= color1 color2)
                       (progn
                         (setq ss (cdr (assoc (fix (atof color1)) sslst)))
                         (command "_CHPROP" ss "" "_COLOR" color2 "")
                       )))))
  (setq _lst lst)
  (foreach x _lst (setq color1 (car x))
           (setq color2 (cadr x))
           (if (and (member color1 blk_lst)
                 (/= color1 color2)
               )
             (progn
               (setq rst 1)
               (while (setq blk (tblnext "BLOCK" rst))
                 (setq rst nil
                       ent (dxf_data -2 blk)
                       entl (entget ent)
                       kolor (dxf_data 62 entl) nent ent)
                 (if (and kolor
                       (= kolor (fix (atof color1)))
                     )
                   (progn
                     (setq entl (subst (cons 62 (fix (atof color2)))
                                       (assoc 62 entl) entl
                                ))
                     (entmod entl)
                   )
                 )
                 (while (setq nent (entnext nent))
                   (if (/= "SEQEND" (dxf_data 0 (setq entl (entget nent))))
                     (progn
                       (setq kolor (dxf_data 62 entl))
                       (if (and kolor
                             (= kolor (fix (atof color1)))
                           )
                         (progn
                           (setq entl (subst (cons 62 (fix (atof color2)))
                                             (assoc 62 entl) entl
                                      ))
                           (entmod entl)
                         ))))))))
  )
  (foreach x lst (setq color1 (car x))
           (setq color2 (cadr x)
                 rst T)
           (if (and (member color1 lay_lst)
                 (/= color1 color2)
               )
             (while (setq l (tblnext "LAYER" rst))
               (setq col (rtos (dxf_data 62 l) 2 0)
                     $layer (dxf_data 2 l)
                     rst nil)
               (if (= col color1)
                 (command "_LAYER" "_COLOR" (fix (atof color2)) $layer "")
               )))
  )
  (command "_regen")
  (princ)
)

(defun get_color_list ( )
  (setq lst lay_lst)
  (if blk_lst (foreach x blk_lst (if (not (member x lst))(setq lst (cons x lst)))))
  (if ent_lst (foreach x ent_lst (if (not (member x lst))(setq lst (cons x lst)))))
  (setq str_lst nil)
  (foreach x lst (setq chk$ x)
           (if (member x lay_lst)(setq chk$ chk$))
           (if (member x blk_lst)(setq chk$ chk$))
           (if (member x ent_lst)(setq chk$ chk$))
           (setq str_lst (cons chk$ str_lst))
  )
  (setq str_lst (reverse str_lst)
        nlst nil)
  (foreach x lst (setq nlst (cons (list x x) nlst)))
  (setq nlst (reverse nlst)
        lst nlst)

)

(defun build_boxes ( )
    (setq oldcolor (car (nth lst_id lst))
          newcolor (cadr (nth lst_id lst))
          box_num_old (strcat "c" (rtos lst_id) "old")
          box_num_new (strcat "c" (rtos lst_id) "new")
          old_col_num (strcat "c" (rtos lst_id) "onum")
          new_col_num (strcat "c" (rtos lst_id) "nnum")
    )
    (set_tile new_col_num "")
    (set_tile new_col_num newcolor)
    (set_tile old_col_num "")
    (set_tile old_col_num oldcolor)
(draw_color oldcolor newcolor)
)

(defun get_color_data ( )
(setq box_num_old $key
      box_num_new $key
      oldcolor (car (nth LST_ID lst)))
(if (= oldcolor nil) (alert "       Can't change non-existent color! \nChoose a color from the displayed palette")
 (progn
   (setq newcolor (cadr (nth LST_ID lst)))
   (get_color)
   (build_boxes)
 )
)
)

(defun C:globalc ()

(setvar "cmdecho" 0)
(initerr)
(COMMAND "UNITS" "2" "0" "" "" "" "")
(scan_for_colors)
(get_color_list)

   (setq dcl_id (load_dialog "globalc.dcl"))
   (if (not (new_dialog "globalc" dcl_id)) (exit))

   (setq lst_id 0)
   (repeat (length lst)
   (build_boxes)
   (setq lst_id (+ lst_id 1))
   )

   (action_tile "c0new"  "(setq lst_id 0) (get_color_data)")
   (action_tile "c1new"  "(setq lst_id 1) (get_color_data)")
   (action_tile "c2new"  "(setq lst_id 2) (get_color_data)")
   (action_tile "c3new"  "(setq lst_id 3) (get_color_data)")
   (action_tile "c4new"  "(setq lst_id 4) (get_color_data)")
   (action_tile "c5new"  "(setq lst_id 5) (get_color_data)")
   (action_tile "c6new"  "(setq lst_id 6) (get_color_data)")
   (action_tile "c7new"  "(setq lst_id 7) (get_color_data)")
   (action_tile "c8new"  "(setq lst_id 8) (get_color_data)")
   (action_tile "c9new"  "(setq lst_id 9) (get_color_data)")
   (action_tile "c10new" "(setq lst_id 10)(get_color_data)")
   (action_tile "c11new" "(setq lst_id 11)(get_color_data)")
   (action_tile "c12new" "(setq lst_id 12)(get_color_data)")
   (action_tile "c13new" "(setq lst_id 13)(get_color_data)")
   (action_tile "c14new" "(setq lst_id 14)(get_color_data)")
   (action_tile "c15new" "(setq lst_id 15)(get_color_data)")
   (action_tile "c16new" "(setq lst_id 16)(get_color_data)")
   (action_tile "c17new" "(setq lst_id 17)(get_color_data)")
   (action_tile "c18new" "(setq lst_id 18)(get_color_data)")
   (action_tile "c19new" "(setq lst_id 19)(get_color_data)")

   (action_tile "ok" "(done_dialog 1)")
   (action_tile "exit" "(done_dialog 0)")

   (setq dexit (start_dialog))
   (cond
     ((= dexit 0))
     ((= dexit 1)(princ "\nChanging colors... please wait")(princ)(go_change))
   )
   (unload_dialog dcl_id)
   (princ)
)
(princ "loaded.")
(prin1)
